#include "gdockedapp.h"
#import "dock.h"

@implementation GDMainLogo

- (id)initWithAppPath:(NSString *)aPath inDockWin:(GDWindow *)aWin
{
	self = [super initWithFrame: NSMakeRect(0, 0, 64, 64)];
	if(self) {
		dockWin = [aWin retain];
		tile = [[NSImage imageNamed:@"common_Tile.tiff"] retain];
		appIcon = [NSImage imageNamed:@"dock.tiff"];
		isDragTarget = NO;
  		[self registerForDraggedTypes: [NSArray arrayWithObjects: @"FileObj", @"DockObj", nil]];
	}
	return self;
}

- (void)dealloc
{
	[tile release];
	[appIcon release];
	[dockWin release];
	[super dealloc];
}

- (BOOL)acceptsFirstResponder
{
	return YES;
}

- (BOOL)acceptsFirstMouse:(NSEvent *)theEvent
{
	return YES;
}

- (void)mouseDown:(NSEvent*)theEvent
{


}                                                        

- (void)mouseDragged:(NSEvent *)theEvent
{
  	NSPoint location, lastLocation, origin;

  	lastLocation = [theEvent locationInWindow];
  	while([theEvent type] != NSLeftMouseUp) {
    	theEvent = [dockWin nextEventMatchingMask:
        									NSLeftMouseUpMask | NSLeftMouseDraggedMask];
		location = [dockWin mouseLocationOutsideOfEventStream];
		if(NSEqualPoints(location, lastLocation) == NO) {
		   origin = [dockWin frame].origin;
		   origin.x += (location.x - lastLocation.x);
		   origin.y += (location.y - lastLocation.y);
		   [dockWin setFrameOrigin: origin];
		}
	}
	[dockWin registerPosition];
}

- (void)drawRect:(NSRect)rect
{
	NSPoint imgPoint;
	
	[tile compositeToPoint: NSZeroPoint operation: NSCompositeSourceOver];
  	imgPoint = NSMakePoint((64 - [appIcon size].width)/2, (64 - [appIcon size].height)/2);
	[appIcon compositeToPoint: imgPoint operation: NSCompositeSourceOver];
}

@end

