#ifndef GDOCKEDAPP_H
#define GDOCKEDAPP_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

#define DelegateHandles(a) (delegate && [delegate respondsToSelector:@selector(a)])

@class GDWindow;

@interface GDockedApp : NSView
{
	NSImage *tile, *appIcon;
	NSString *appPath;
	GDWindow *dockWin;
	BOOL isDragTarget, dndok;
	int dragdelay;
	id delegate;
}

- (id)initWithAppPath:(NSString *)aPath inDockWin:(GDWindow *)aWin;
- (id)delegate;
- (void)setDelegate:(id)aDelegate;
- (NSString *)appPath;
- (void)setDndOk:(BOOL)value;

@end

@interface GDockedApp (DraggingDestination)

- (unsigned int)draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int)draggingUpdated:(id <NSDraggingInfo>)sender;
- (void)draggingExited:(id <NSDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender;
- (void)concludeDragOperation:(id <NSDraggingInfo>)sender;

@end

@interface GDockedApp (DraggingSource)

- (void)startExternalDragOnEvent:(NSEvent *)event;
- (void)declareAndSetShapeOnPasteboard:(NSPasteboard *)pb;
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)flag;

@end

@interface NSObject(GDockedAppDelegateMethods)
- (BOOL)control:(GDockedApp *)control
 					shouldStartExternalDragOnEvent:(NSEvent *)anEvent;
- (void)control:(GDockedApp *)control
   					didFinishExternalDragOnEvent:(NSEvent *)anEvent;
@end

@interface GDMainLogo : GDockedApp
{}
@end

#endif // GDOCKEDAPP_H
